<?php

class more_types_object extends more_plugins_object_sputnik_1 {
	
	var $settings, $saved, $wp_post_types;

	function init ($settings) {
		$this->settings = $settings;
		add_action('init', array(&$this, 'init_post_types'), 20);
		add_action('admin_init', array(&$this, 'add_boxes_to_post_type'), 50);
		add_filter('template_redirect', array(&$this, 'template_redirect'), 9);
		// Get the default set of post types
		add_action('init', array(&$this, 'set_default_data'), 1);
		// Get modified post type array
		add_action('init', array(&$this, 'set_modified_data'), 19);
	}
	function set_default_data() {
		global $wp_post_types;
		$this->data_default = $wp_post_types;		
	}
	function set_modified_data() {
		global $wp_post_types;
		$this->data_modified = $wp_post_types;	
	}
	function add_boxes_to_post_type () {
	
		$pages = $this->get_data(array('_plugin_saved', '_plugin'));

		foreach ($pages as $name => $page) {
			if (is_callable('add_meta_box')) {
				$box_data = $this->get_existing_boxes();
				foreach((array) $page['boxes'] as $box_key) {
					$box = $box_data[$box_key];
					add_meta_box($box['id'], $box['title'], $box['callback'], $name, 'normal');
				}
			}	
		}
	}
	function template_redirect() {
		if (is_single()) {
			$pt = get_post_type();
			$mt = $this->read_data();
			if ($template = $mt[$pt]['template']) {
				$file = TEMPLATEPATH . '/' .$template;
				if (file_exists($file)) {
					include($file);
					exit(0);
				}
				return false;
			}
		}
	}
	function get_existing_boxes () {
		global $wp_meta_boxes;
		$data = $wp_meta_boxes;
		$boxes = array();
		foreach ((array) $data as $data1) {
			foreach ((array) $data1 as $data2) {
				foreach ((array) $data2 as $data3) {
					foreach ((array) $data3 as $box) {
						 if ($title = $box['title']) {
							 $boxes[$box['id']] = $box;
						 }
					}
				}
			}						
		}
		return $boxes;
	}
	function read_data() {
		global $wp_post_types;

		// Get data from db
		$data = $this->load_data();


//		$data['plugin'] = get_option($this->settings['option_key'], array());
		
//		$data['plugin_saved'] = 

//print_r($data);
//exit;
		// Data save to file
	//	$data = $this->saved_data($data);
		
		// Data added eslewhere
//		if (!$this->wp_post_types) $this->wp_post_types = $wp_post_types;
//		$data = $this->elsewhere_data($data, $this->wp_post_types);

		return $data;
	}
	function init_post_types() {
		global $wp_post_types;
		
		$pages = $this->get_data(array('_plugin_saved', '_plugin'));

		$caps = array(
			'edit_cap' => 'edit_%',
			'edit_type_cap' => 'edit_%s', 
			'edit_others_cap' => 'edit_others_%s',
			'publish_others_cap' => 'publish_%s',
			'read_cap' => 'read_%',
			'delete_cap' => 'delete_%'
		);

		foreach($pages as $name => $page) {


			$options = array();

			foreach ($caps as $cap_key => $template) {
				// Create the capability name
				$capability = str_replace('%', $name, $template);

				// Add capabilities to the post type if there are defined roles
				if (!empty($page['more_' . $cap_key])) 
					$options[$cap_key] = $capability;

				// Add capability!
				foreach ((array) $page['more_' . $cap_key] as $role) {				
					$wp_roles->add_cap($role, $capability);
				}

			}

			// Fill our options paramete
			$options = $this->populate($page, $options);

			foreach ((array) $page['boxes'] as $box) {
				$options['supports'][] = $box;
			}

			// Some legacy labels
			if (array_key_exists('label', $page) && !$options['labels']['name']) 
				$options['labels']['name'] = $page['label'];
			if (array_key_exists('singular_label', $page) && !$options['labels']['singular_name']) 
				$options['labels']['singular_name'] = $page['singular_label'];

			// Default text labels
			$default_labels = array(
				'add_new' => __('Add new', 'more-plugins'),
				'add_new_item' => __('Add new item', 'more-plugins'), 
				'edit_item' => __('Edit item', 'more-plugins'),
				'new_item' => __('New item', 'more-plugins'),
				'view_item' => __('View item', 'more-plugins'),
				'search_items' => __('Search item', 'more-plugins'),
				'not_found' => __('No items found', 'more-plugins'), 
				'not_found_in_trash' => __('No items found in Trash', 'more-plugins') 
			);
			foreach ($default_labels as $key => $text) {
				if (!$options['labels'][$key]) $options['labels'][$key] = $text;
			}
			
			if ($page['rewrite_bool'] && ($rw = $page['rewrite_slug'])) $options['rewrite'] = array('slug' => $rw);
			else $options['rewrite'] = false;
			
			if ($options['revisions']) $options['supports'][] = 'revisions';
			
			// Remove if nowt is set
			if (!$options['menu_icon']) unset($options['menu_icon']);

			// We'll add taxonomies below
			$options['taxonomies'] = array();

			// Menu position must be an integer 
			if ($mp = $options['menu_position']) $options['menu_position'] = intval($mp);

			// Is this one of the default ones?
			// if (in_array($name, $defaults)) $options['_builtin'] = true;
			register_post_type($name, $options);

       	 	foreach ((array) $page['taxonomies'] as $taxonomy)  {
        		register_taxonomy_for_object_type($taxonomy, $name);
			}		
		}

		//exit();

	}
	
} // End class


?>