<?php
/*
Plugin Name: More Types
Version: 1.0rc1
Author URI: http://labs.dagensskiva.com/
Plugin URI: http://labs.dagensskiva.com/
Description:  Add more post types to your WordPress installation. 
Author: Henrik Melin, Kal Ström

	USAGE:

	See http://labs.dagensskiva.com/

	LICENCE:

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
    
    
*/


/* 
** 		MANUAL RESET ** DELETES ALL DATA STORED IN MORE TYPES **
**
** 		To reset More Types completely change false to true, click on 
** 		Settings->More Types, the set it back to false
*/
if (false) update_option('more_types', array());

// Plugin settings
$fields = array(
		'var' => array('description', 'menu_icon', 'public', 'label', 'singular_label', 'name', 'exclude_from_search', 
		'publicly_queryable', 'show_ui', 'inherit_type', 'capability_type', 'hierarchical', 'template', 'rewrite_bool', 
		'rewrite_slug', 'revisions','can_export', 'menu_position'),
		'array' => array('supports', 'more_edit_type_cap', 'more_edit_cap', 'more_edit_others_cap', 'more_publish_others_cap', 'more_read_cap', 'more_delete_cap', 'taxonomies', 'boxes',
			'labels' => array('name', 'singular_name', 'add_item', 'add_new_item', 'edit_item', 'new_item', 'view_item', 'search_item', 'not_found', 'not_found_in_trash'))
);
$default = array(
		'show_ui' => true,
		'publicly_queryable' => true,
		'hierarchical' => false,
		'public' => true,
		'capability_type' => 'post', 
		'supports' => array('title', 'editor'),
		'rewrite_bool' => false,
		'revisions' => true,
		'can_export' => true,
		'show_in_nav_menus' => true,
);
$default_keys = array('post', 'page', 'revision', 'media', 'attachment', 'nav_menu_item');

$settings = array(
		'name' => 'More Types', 
		'option_key' => 'more_types',
		'fields' => $fields,
		'default' => $default,
		'default_keys' => $default_keys,
);

// Always on components
//include(ABSPATH . '/wp-content/plugins/more-plugins.php');
include('more-plugins/more-plugins.php');
include('more-types-object.php');

$more_types = new more_types_object($settings);

// Load admin components
if (is_admin()) {
	// include(ABSPATH . '/wp-content/plugins/more-plugins-admin.php');
	include('more-plugins/more-plugins-admin.php');
	include('more-types-settings-object.php');
	$more_types_settings = new more_types_admin($settings);
}

/*

function post_type_movies() {
	register_post_type(
		'movie', 
			array(
				'labels' => array('name' => 'Movies', 'singular_name' => 'Movie'),
				'public' => true,
				'show_ui' => true,
				'supports' => array(
							 'post-thumbnails',
							 'excerpts',
							 'trackbacks',
							 'custom-fields',
							 'comments',
							 'revisions')
			)
        );
 
	register_taxonomy( 'actor', 'movies', array( 'hierarchical' => true, 'label' => __('Actor') ) ); 
 
        register_taxonomy( 'production', 'movies',
		array(
                         'hierarchical' => false,
			 'label' => __('Production'),
			 'query_var' => 'production',
			 'rewrite' => array('slug' => 'production' )
		)
	);
}
add_action('init', 'post_type_movies');

*/

?>
